#!/bin/bash -e

APP_TYPE="$1" # shell or python
SCRIPTS_DIR=$(cd $(dirname "$0"); pwd)
PROJECT_HOME="$SCRIPTS_DIR/.."
ARCH=$(jq -r .arch "$PROJECT_HOME/info.json") || exit
APP_DIR="$PROJECT_HOME/app_$ARCH"
REL_FILES_DIR="$PROJECT_HOME/container_$ARCH/release"
RESOURCES_DIR="resources"
APP_INSTALL_DIR="$REL_FILES_DIR/$RESOURCES_DIR/root/${APP_TYPE}_app"
IMAGE_NAME="${APP_TYPE}_app_release_image"
DESC_FILE="$REL_FILES_DIR/${IMAGE_NAME}.desc"

gen_swu() {
    version=1

    if [ -e "$DESC_FILE" ]; then
        version=$(awk -F= '$1 == "swdesc_option version" { print $2 + 1 }' "$DESC_FILE")
        mv -f "$DESC_FILE" "$DESC_FILE".old
    fi
    cat > "$DESC_FILE" <<EODESC
swdesc_option version=${version:-1}

swdesc_files --extra-os root
swdesc_embed_container "${IMAGE_NAME}.tar"
EODESC

    cd "$REL_FILE_DIR"
    mkswu "$DESC_FILE"
}

mkdir -p "$APP_INSTALL_DIR"
cp -rf "$APP_DIR"/* "$APP_INSTALL_DIR"

"$SCRIPTS_DIR"/build_container_image.sh "$APP_TYPE" release

gen_swu
